//scripts
// global variables
var scene;
var renderer;
// used for drag and drop

var selectedObject;
var offset = new THREE.Vector3();
var objects = [];
var container, controls, clock, selection;

var init, initializeLesson;
var canvas, scene, renderer, camera;

var raycaster; // A THREE.Raycaster for user mouse input.

var ground; // A square base on which the cylinders stand.
var cylinder; // A cylinder that will be cloned to make the visible cylinders.

var world, animate; // An Object3D that contains all the mesh objects in the scene.
// Rotation of the scene is done by rotating the world about its
// y-axis.  (I couldn't rotate the camera about the scene since
// the Raycaster wouldn't work with a camera that was a child
// of a rotated object.)
raycaster = new THREE.Raycaster();
var mouseAction; // currently selected mouse action
var dragItem; // the cylinder that is being dragged, during a drag operation
var intersects; //the objects intersected

var plane; // An invisible object that is used as the target for raycasting while
// dragging a cylinder.  I use it to find the new location of the
// cylinder.  I tried using the ground for this purpose, but to get
// the motion right, I needed a target that is at the same height
// above the ground as the point where the user clicked the cylinder.

function animate() {

	requestAnimationFrame( animate );
	renderer.render( scene, camera );

}

function initializeLesson() {

	init();

}




function init() {

	    // Prepare container
	container = document.createElement( 'div' );
	document.body.appendChild( container );
	scene = new THREE.Scene();
	camera = new THREE.PerspectiveCamera( 75, window.innerWidth / window.innerHeight, 0.1, 1000 );
	camera.position.z = 50;
	camera.position.y = 50;
	camera.position.x = 30;// added to get a better control on screen
	camera.lookAt( new THREE.Vector3( 0, 0, 0 ) );


	renderer = new THREE.WebGLRenderer( { antialias: true } );
	renderer.setClearColor( "#e5e5e5" ); //setting a grey color on the screen
	renderer.setPixelRatio( window.devicePixelRatio );
	renderer.setSize( window.innerWidth, window.innerHeight ); //adjusting the black screen on the browser
	document.body.appendChild( renderer.domElement );
	window.addEventListener( 'resize', () => {

		renderer.setSize( window.innerWidth, window.innerHeight );
		camera.aspect = window.innerWidth / window.innerHeight;
		camera.updateProjectionMatrix(); //today edited

	} );




	container.appendChild( renderer.domElement );

	var groundlength = 2000;
	var groundheight = 0;
	var groundwidth = 1000;
	var geometry = new THREE.BoxGeometry( groundlength, groundheight, groundwidth );
	var material = new THREE.MeshBasicMaterial( { map: new THREE.TextureLoader().load( 'textures/6.jpg' ) } ); //B5651D
	var ground = new THREE.Mesh( geometry, material );
	ground.position.x = groundlength / 2;
	ground.position.z = groundwidth / 2;
	ground.position.y = - 0.5;
	scene.add( ground );
	var axessize = 2 * groundlength;
	var axes = new THREE.AxesHelper( 1000 ); //to view x y z axis
	scene.add( axes );


	controls = new THREE.OrbitControls( camera, renderer.domElement );
	controls.minDistance = 1;
	controls.maxDistance = 1000;
	controls.target = new THREE.Vector3( 0, 0, 0 );
	clock = new THREE.Clock();


	//plane = new THREE.Mesh(new THREE.BoxGeometry(groundlength, groundheight, groundwidth), new THREE.MeshBasicMaterial({color: 0xffffff}));
	//  plane.visible = false;
	var plane = new THREE.Mesh( new THREE.BoxGeometry( groundlength, 1, groundwidth ), new THREE.MeshBasicMaterial( {
		color: 0xffff00,
		opacity: 0.50,
		transparent: true
		//,visible: false
	} ) );
	plane.position.x = groundlength / 2;
	plane.position.z = groundwidth / 2;
	plane.position.y = 0;
	scene.add( plane );

	function onDocumentMouseDown( event ) {

		// Get mouse position
		console.log( 'onDocumentMouseDown' );



		var mouseX = ( event.clientX / window.innerWidth ) * 2 - 1;
		var mouseY = - ( event.clientY / window.innerHeight ) * 2 + 1;

		// Get 3D vector from 3D mouse position using 'unproject' function
		var vector = new THREE.Vector3( 1, mouseY, mouseX );
		vector.unproject( camera );

		// Set the raycaster position
		var raycaster = new THREE.Raycaster( camera.position, vector.sub( camera.position ).normalize() );

		// Find all intersected objects
		var intersects = raycaster.intersectObjects( objects );

		if ( intersects.length > 0 ) {

			// Disable the controls
			controls.enabled = false;

			// Set the selection - first intersected object
			selection = intersects[ 0 ].object;

			// Calculate the offset
			var intersects = raycaster.intersectObject( plane );
			offset.copy( intersects[ 0 ].point ).sub( selection.position );
			// container.style.cursor = 'move';

		}

	}
	function onDocumentMouseMove( event ) {

		event.preventDefault();

		// Get mouse position
		var mouseX = ( event.clientX / window.innerWidth ) * 2 - 1;
		var mouseY = - ( event.clientY / window.innerHeight ) * 2 + 1;

		// Get 3D vector from 3D mouse position using 'unproject' function
		// var vector = new THREE.Vector3(mouseX, mouseY, 1);
		var vector = new THREE.Vector3( 1, mouseY, mouseX );

		vector.unproject( camera );

		// Set the raycaster position
		var raycaster = new THREE.Raycaster( camera.position, vector.sub( camera.position ).normalize() );

		if ( selection ) {

			// Check the position where the plane is intersected
			var intersects = raycaster.intersectObject( plane );
			// Reposition the object based on the intersection point with the plane
			selection.position.copy( intersects[ 0 ].point.sub( offset ) );

		} else {

			// Update position of the plane if need
			var intersects = raycaster.intersectObjects( objects );
			if ( intersects.length > 0 ) {

				plane.position.copy( intersects[ 0 ].object.position );
				// plane.lookAt(camera.position);

			}

		}

	}
	function onDocumentMouseUp( event ) {

		// Enable the controls
		controls.enabled = true;
		selection = null;

	}


	THREEx.WindowResize( renderer, camera );
	//document.addEventListener('mousedown', onDocumentMouseDown, false);
	console.log( '1' );
	//document.addEventListener('mousemove',onDocumentMouseMove, false);
	//  document.addEventListener('mouseup', onDocumentMouseUp, false);
	createwarehouse();
	creategoods();
	var dragControls = new THREE.DragControls( objects, camera, renderer.domElement );
	dragControls.addEventListener( 'dragstart', function ( event ) {

		controls.enabled = false;
		event.object.material.color.set( 0xaaaaaa );

	} );

	dragControls.addEventListener( 'dragend', function ( event ) {

		console.log( 'hi' );
		controls.enabled = true;
		event.object.material.color.set( 0xffffff );


	} );

	animate();

}


function createwarehouse() {

	var warehousez = document.getElementById( "Length" ).value;
	var warehousey = document.getElementById( "Width" ).value;
	var warehousex = document.getElementById( "height" ).value;

	warehousez = 300;
	warehousey = 100;
	warehousex = 100;

	var geometry = new THREE.BoxGeometry( warehousez, warehousex, warehousey );
	var cubeMaterials = [
		new THREE.MeshBasicMaterial( { map: new THREE.TextureLoader().load( 'textures/4.jpg' ), side: THREE.DoubleSide } ), // left

		new THREE.MeshBasicMaterial( { map: new THREE.TextureLoader().load( 'textures/4.jpg' ), side: THREE.DoubleSide } ), // right

		new THREE.MeshBasicMaterial( { map: new THREE.TextureLoader().load( 'textures/3.jpg' ), side: THREE.DoubleSide } ), //bottom
		new THREE.MeshBasicMaterial( { map: new THREE.TextureLoader().load( 'textures/3.jpg' ), side: THREE.DoubleSide } ), //top
		new THREE.MeshBasicMaterial( { color: "#FF0000", side: THREE.BackSide } ), // front
		new THREE.MeshBasicMaterial( { map: new THREE.TextureLoader().load( 'textures/3.jpg' ), side: THREE.DoubleSide } ) // grgeen
	];

	var material = new THREE.MeshFaceMaterial( cubeMaterials );
	var warehouse = new THREE.Mesh( geometry, material );

	warehouse.position.x = warehousez / 2;
	warehouse.position.y = ( warehousex / 2 ) + 0.1;
	warehouse.position.z = warehousey / 2;

	scene.add( warehouse );

	animate();

}


function creategoods() {

	var goodsz = document.getElementById( "GoodsLength" ).value;
	var goodsy = document.getElementById( "GoodsWidth" ).value;
	var goodsx = document.getElementById( "Goodsheight" ).value;

	var noofcubes = document.getElementById( "noofgoodscubes" ).value;
	goodsz = 5;
	goodsx = 5;
	goodsy = 5;
	noofcubes = 10;

	var goodsgeometry = new THREE.BoxGeometry( goodsz, goodsy, goodsx );
	var goodsmaterial = new THREE.MeshBasicMaterial( { map: new THREE.TextureLoader().load( 'textures/5.jpg' ) } );

	var goods = new THREE.Mesh( goodsgeometry, goodsmaterial );

	var i;
	resultx = parseInt( goodsz );
	resulty = parseInt( goodsy );
	resultz = parseInt( goodsx );
	resultnoofcubes = parseInt( noofcubes );

	var positionx = resultx / 2;
	var positiony = resulty / 2;
	var positionz = resultz / 2;
	goods.position.y = positiony;
	goods.position.z = positionz;

	for ( i = 1; i <= resultnoofcubes; i ++ ) {

		var obj = goods.clone();
		obj.position.x = positionx;

		scene.add( obj );

		positionx += resultx + 0.5;
		objects.push( obj );

	}
	animate();

}
